<template>
  <div class="appSelectComposite">
    <div
      :class="{ '-disabled': disabled,'-not-empty': isNotEmpty, '-invalid': classes['-invalid'] }"
      class="input inputComposite">
      <AppSelect
        v-model="selected"
        :max-height="200"
        :options="options || []"
        :searchable="true"
        :placeholder="''"
        :disabled="disabled"
        :clear-on-disable="clearOnDisable"
        class="input-field"
        @searching="$emit('searching', $event)"
        @open="onOpen"
        @clear="onClear"
        @close="onClose"
        @select="onSelect">
        <template slot="noResult">
          Не найдено
        </template>
      </AppSelect>
      <span class="inputComposite-label">
        <slot name="label"/>
      </span>
    </div>
  </div>
</template>

<script>
import AppSelect from '~/components/redesign/app-select/app-select';

export default {
  name: 'AppSelectComposite',
  components: {
    AppSelect,
  },
  props: {
    value: {
      type: Object,
      default: null,
    },
    classes: {
      type: Object,
      default() { return {}; },
    },
    placeholder: {
      type: String,
      default: '',
    },
    options: {
      type: Array,
      default() { return []; },
    },
    disabled: {
      type: Boolean,
      default: false,
    },
    clearOnDisable: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      loading: false,
      opened: false,
      hasValue: Boolean(this.value) || false,
      selected: this.value || null,
    };
  },
  computed: {
    isNotEmpty() {
      return !this.disabled && (this.opened || this.hasValue);
    },
  },
  watch: {
    disabled(newVal) {
      if (newVal === true) {
        this.selected = null;
        this.$emit('input', this.selected);
        this.hasValue = false;
      }
    },
  },
  methods: {
    onSelect(value) {
      this.selected = value;
      this.$emit('input', this.selected);
      this.hasValue = true;
    },
    onOpen() {
      this.opened = true;
    },
    onClose() {
      this.opened = false;
    },
    onClear() {
      this.hasValue = false;
      this.$emit('input', null);
    },
  },
};
</script>

<style lang="postcss">
.appSelectComposite {
  position: relative;
  & .-disabled {
    .multiselect {
      background-color: var(--bg-lightest);

      &.input-field.multiselect--selected {
        background-color: var(--bg-lightest);
      }
    }
  }

  .multiselect__tags,
  .multiselect__input {
    border: none !important;
    background-color: #fff !important;
    box-shadow: none !important;
    outline: none;
    padding: 0;
    margin: 0;
  }
  .multiselect.multiselect--selected .multiselect__tags:after {
    display: none;
  }
  .multiselect.input-field.multiselect--selected {
    background-color: #fff;
  }
  .multiselect.input-field.multiselect--active {
    box-shadow: inset 0 0 0 1px var(--form-focus-border-color);
  }
  .multiselect__content-wrapper {
    right: 0;
  }

  .inputComposite {
    position: static;
    &-label {
      z-index: 2;
    }
  }
}
</style>
